package com.fjhx.sale.service.contract.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.item.service.product.ProductInfoService;
import com.fjhx.sale.entity.contract.po.ContractOutboundInfo;
import com.fjhx.sale.entity.contract.po.ContractOutboundRecords;
import com.fjhx.sale.entity.contract.vo.ContractOutboundInfoVo;
import com.fjhx.sale.entity.contract.vo.ContractOutboundRecordsVo;
import com.fjhx.sale.mapper.contract.ContractOutboundInfoMapper;
import com.fjhx.sale.service.contract.ContractOutboundInfoService;
import com.fjhx.sale.service.contract.ContractOutboundRecordsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * <p>
 * 销售出货信息 服务实现类
 * </p>
 *
 * @author
 * @since 2024-03-13
 */
@Service
public class ContractOutboundInfoServiceImpl extends ServiceImpl<ContractOutboundInfoMapper, ContractOutboundInfo> implements ContractOutboundInfoService {

    @Autowired
    private ContractOutboundRecordsService contractOutboundRecordsService;
    @Autowired
    private ProductInfoService productInfoService;

    @Override
    public ContractOutboundInfoVo detail(Long id) {
        ContractOutboundInfoVo detail = baseMapper.detail(id);
        List<ContractOutboundRecords> list = contractOutboundRecordsService.list(q -> q.eq(ContractOutboundRecords::getRecordId, id));
        List<ContractOutboundRecordsVo> contractOutboundRecordsVos = BeanUtil.copyToList(list, ContractOutboundRecordsVo.class);
        //赋值产品信息
        productInfoService.attributeAssign(contractOutboundRecordsVos, ContractOutboundRecordsVo::getProductId, (item, productInfo) -> {
            item.setProductCode(productInfo.getCode());
            item.setProductName(productInfo.getName());
            item.setProductLength(productInfo.getLength());
            item.setProductWidth(productInfo.getWidth());
            item.setProductHeight(productInfo.getHeight());
            item.setProductColor(productInfo.getColor());

            item.setProductUnit(productInfo.getUnit());
            item.setProductNetWeight(productInfo.getNetWeight());
            item.setProductReverseTexture(productInfo.getReverseTexture());
            item.setProductFrontalTexture(productInfo.getFrontalTexture());
        });

        detail.setOutboundRecordList(contractOutboundRecordsVos);
        return detail;
    }
}
